﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.Graphics.Pdf;
using Android.OS;
using Android.Print;
using Android.Print.Pdf;
using Android.Runtime;
using Android.Views;
using Android.Webkit;
using Android.Widget;
using Java.IO;
using static Android.Print.PrintDocumentAdapter;

namespace XFPDF.Droid
{
    public class CustomWebView : WebViewClient
    {
        Java.IO.File filePath = null;

        public CustomWebView(Java.IO.File path)
        {
            this.filePath = path;
        }

        public override void OnPageFinished(Android.Webkit.WebView myWebview, string url)
        {
            base.OnPageFinished(myWebview, url);

            PrintAttributes attributes = new PrintAttributes.Builder()
         .SetMediaSize(PrintAttributes.MediaSize.IsoA4)
         .SetResolution(new PrintAttributes.Resolution("pdf", "pdf", 600, 600))
         .SetMinMargins(PrintAttributes.Margins.NoMargins).Build();

            PrintManager printManager = (PrintManager)DeviceHelper.MainActivity.GetSystemService(Android.Content.Context.PrintService);
            var printAdapter = myWebview.CreatePrintDocumentAdapter();
            ////   var printAdapter = new GenericPrintAdapter(DeviceHelper.MainActivity, myWebview);
            PdfPrint pdfPrint = new PdfPrint(attributes);

            pdfPrint.Print(printAdapter, filePath, "Datengut.pdf");

            //printManager.Print("MyPrintJob", printAdapter, null);

            //Java.IO.File path = Android.OS.Environment.GetExternalStoragePublicDirectory(Android.OS.Environment.DirectoryDcim + "/PDFTest/");
            //PdfPrint pdfPrint = new PdfPrint(attributes);
            //pdfPrint.Print(myWebview.CreatePrintDocumentAdapter("Datengut_Winjit"), path, ".pdf");


            //PdfDocument document = new PdfDocument();
            //PdfDocument.Page page = document.StartPage(new PdfDocument.PageInfo.Builder(2120, 3000, 5).Create());

            //myWebview.Draw(page.Canvas);
            //document.FinishPage(page);
            //Stream filestream = new MemoryStream();
            //FileOutputStream fos = new Java.IO.FileOutputStream(filePath, false); ;
            //try
            //{
            //    document.WriteTo(filestream);
            //    fos.Write(((MemoryStream)filestream).ToArray(), 0, (int)filestream.Length);
            //    fos.Close();
            //    System.Diagnostics.Debug.WriteLine("Completed");
            //}
            //catch
            //{
            //}
        }
    }

    //public class GenericPrintAdapter : PrintDocumentAdapter
    //{
    //    View view;
    //    Context context;
    //    PrintedPdfDocument document;
    //    float scale;

    //    public GenericPrintAdapter(Context context, View view)
    //    {
    //        this.view = view;
    //        this.context = context;
    //    }

    //    public override void OnLayout(PrintAttributes oldAttributes, PrintAttributes newAttributes,
    //                                   CancellationSignal cancellationSignal, LayoutResultCallback callback, Bundle extras)
    //    {
    //        document = new PrintedPdfDocument(context, newAttributes);

    //        PrintAttributes.MediaSize pageSize = newAttributes.GetMediaSize();

    //        CalculateScale(newAttributes);

    //        var printInfo = new PrintDocumentInfo
    //            .Builder("MyPrint.pdf")
    //            .SetContentType(PrintContentType.Document).SetPageCount(59)
    //            .Build();

    //        callback.OnLayoutFinished(printInfo, true);
    //    }

    //    void CalculateScale(PrintAttributes newAttributes)
    //    {
    //        int dpi = Math.Max(newAttributes.GetResolution().HorizontalDpi, newAttributes.GetResolution().VerticalDpi);

    //        int leftMargin = (int)(dpi * (float)newAttributes.MinMargins.LeftMils / 1000);
    //        int rightMargin = (int)(dpi * (float)newAttributes.MinMargins.RightMils / 1000);
    //        int topMargin = (int)(dpi * (float)newAttributes.MinMargins.TopMils / 1000);
    //        int bottomMargin = (int)(dpi * (float)newAttributes.MinMargins.BottomMils / 1000);

    //        int w = (int)(dpi * (float)newAttributes.GetMediaSize().WidthMils / 1000) - leftMargin - rightMargin;
    //        int h = (int)(dpi * (float)newAttributes.GetMediaSize().HeightMils / 1000) - topMargin - bottomMargin;

    //        scale = Math.Min((float)document.PageContentRect.Width() / w, (float)document.PageContentRect.Height() / h);
    //    }

    //    public override void OnWrite(PageRange[] pages, ParcelFileDescriptor destination,
    //                                  CancellationSignal cancellationSignal, WriteResultCallback callback)
    //    {
    //        PrintedPdfDocument.Page page = document.StartPage(0);

    //        page.Canvas.Scale(scale, scale);

    //        view.Draw(page.Canvas);

    //        document.FinishPage(page);

    //        WritePrintedPdfDoc(destination);

    //        document.Close();

    //        document.Dispose();

    //        callback.OnWriteFinished(pages);
    //    }

    //    void WritePrintedPdfDoc(ParcelFileDescriptor destination)
    //    {
    //        var javaStream = new Java.IO.FileOutputStream(destination.FileDescriptor);
    //        var osi = new OutputStreamInvoker(javaStream);
    //        using (var mem = new MemoryStream())
    //        {
    //            document.WriteTo(mem);
    //            var bytes = mem.ToArray();
    //            osi.Write(bytes, 0, bytes.Length);
    //        }
    //    }
    //}
}