﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Print;
using Android.Runtime;
using Android.Util;
using Android.Views;
using Android.Widget;
using Java.IO;
using static Android.Print.PrintDocumentAdapter;

namespace XFPDF.Droid
{
      [Register("android/print/CustomPrintDocumentAdapter")]
    public class CustomPrintDocumentAdapter : LayoutResultCallback
    {
        private PrintDocumentAdapter printAdapter; 
        public CustomPrintDocumentAdapter(PrintDocumentAdapter printAdapter, IntPtr javaReference, JniHandleOwnership transfer) : base(IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
        {
            this.printAdapter = printAdapter;
        }

        public override void OnLayoutFinished(PrintDocumentInfo info, bool changed)
        {
            File sdf = Android.OS.Environment.GetExternalStoragePublicDirectory(Android.OS.Environment.DirectoryDownloads);
            ParcelFileDescriptor fileDescriptor = getOutputFile(sdf, "SMV_Report");
            printAdapter.OnWrite(new PageRange[] { PageRange.AllPages }, fileDescriptor, new CancellationSignal(),
             new MyWriteResultCallback(JNIEnv.Handle, JniHandleOwnership.DoNotRegister));

            base.OnLayoutFinished(info, changed);
        }
        public ParcelFileDescriptor getOutputFile(File path, String fileName)
        {
            if (!path.Exists())
            {
                path.Mkdirs();
            }
            File file = new File(path, fileName);
            try
            {
                file.CreateNewFile();
                return ParcelFileDescriptor.Open(file, ParcelFileMode.ReadWrite);
            }
            catch (Exception e)
            {
                Log.Error("ssss", "Failed to open ParcelFileDescriptor", e);
            }
            return null;
        }
    }

    [Register("android/print/MyWriteResultCallback")]
    public class MyWriteResultCallback : PrintDocumentAdapter.WriteResultCallback
    {
        public MyWriteResultCallback(IntPtr javaReference, JniHandleOwnership transfer) : base(javaReference, transfer)
        {
        }

        public override void OnWriteFinished(PageRange[] pages)
        {
            base.OnWriteFinished(pages);
        }
    }
}